package
{
	import flash.utils.ByteArray;
	
	public class BitArray extends ByteArray
	{
		private static const INTERGER_SIZE:uint = 32;
		private static const BYTE_SIZE:uint = 8;
		private var _position:uint = 0;
		
		public function BitArray():void
		{
			
		}
		
		public function align():void
		{
			var gap:uint = this.position % BYTE_SIZE;
			if(gap > 0)
				this.position += BYTE_SIZE - gap;
		}
		/*
		 * The lenght of BitArray object, in bits.
		 */
		override public function get length():uint 
		{
			return super.length * BYTE_SIZE;
		}
		
		override public function set length(value:uint):void
		{
			super.length = Math.ceil(value / BYTE_SIZE);
		}
		
		public function get bitsAvailable():uint
		{
			return this.length - this.position;
		}
		
		override public function get position():uint
		{
			return this._position;
		}
		
		override public function set position(value:uint):void
		{
			this._position = value;
		}
		
		public function readUnsignedBits(size:uint):uint
		{
			var initialPosition:uint = this.position;
			var bitPosition:uint = initialPosition % BYTE_SIZE;
			super.position = (initialPosition - bitPosition) / BYTE_SIZE;
			var tempValue:uint = super.readUnsignedByte();
			var tmpSize:uint = Math.min(BYTE_SIZE - bitPosition, size);
			var currentSize:uint = tmpSize;
			var value:uint = tempValue >>> BYTE_SIZE - (bitPosition + tmpSize) & 0xffffffff >>> INTERGER_SIZE - tmpSize;
			
			while (currentSize < size)
			{
				tmpSize = Math.min(size - currentSize, BYTE_SIZE);
				tempValue = super.readUnsignedByte();
				currentSize += tmpSize;
				value = value << tmpSize | tempValue >>> BYTE_SIZE - tmpSize & (0xffffffff >>> INTERGER_SIZE - tmpSize);
			}
			this.position += currentSize;
			return value;
		}
		
		public function readBits(size:uint):int
		{
			//return this.readBitSign() * this.readUnsignedBits(size -1);
			return this.readUnsignedBits(size) << (INTERGER_SIZE - size) >> (INTERGER_SIZE - size);
		}
		/*
		private function readBitSign():int
		{
			return this.readBoolean() ? -1 : 1;
		}
		*/
		
		/*
		 * Reads a Boolean value from the byte stream.
		 */
		override public function readBoolean():Boolean 
		{
			return Boolean(this.readUnsignedBits(1));
		}
		
		/*
		 * Reads a signed byte from the byte stream.
		 */
		override public function readByte():int 
		{
			return this.readBits(BYTE_SIZE);
		}
		
		/*override public function readBytes(bytes:ByteArray, offset:uint = 0, length:uint = 0):void 
		{
			super.readBytes(bytes, offset, length);
		}*/
		
		override public function readDouble():Number 
		{
			return 0;
		}
		
		override public function readFloat():Number 
		{
			return 0;
		}
		
		override public function readInt():int 
		{
			return this.readBits(INTERGER_SIZE);
		}
		
		override public function readMultiByte(length:uint, charSet:String):String 
		{
			return "";
		}
		
		override public function readShort():int 
		{
			return 0;
		}
		
		override public function readUnsignedByte():uint 
		{
			return this.readUnsignedBits(BYTE_SIZE);
		}
		
		override public function readUnsignedInt():uint 
		{
			return this.readUnsignedBits(INTERGER_SIZE);
		}
		
		override public function readUnsignedShort():uint 
		{
			return 0;
		}
		
		override public function readUTF():String 
		{
			return "";
		}
		
		override public function readUTFBytes(length:uint):String 
		{
			return "";
		}
		
		override public function writeBoolean(value:Boolean):void 
		{
			void;
		}
		
		override public function writeByte(value:int):void 
		{
			void;
		}
		
		override public function writeBytes(bytes:ByteArray, offset:uint = 0, length:uint = 0):void 
		{
			void;
		}
		
		override public function writeDouble(value:Number):void 
		{
			void;
		}
		
		override public function writeFloat(value:Number):void 
		{
			void;
		}
		
		override public function writeInt(value:int):void 
		{
			void;
		}
		
		override public function writeMultiByte(value:String, charSet:String):void 
		{
			void;
		}
		
		override public function writeObject(object:*):void 
		{
			void;
		}
		
		override public function writeShort(value:int):void 
		{
			void;
		}
		
		override public function writeUnsignedInt(value:uint):void 
		{
			void;
		}
		
		override public function writeUTF(value:String):void 
		{
			void;
		}
		
		override public function writeUTFBytes(value:String):void 
		{
			void;
		}
	}
}